﻿
//General globals. 
var layBack,layFront,laySamp,layDoc,scrollIcons;
var textSize=12, timer=0, lastLine=0;
var textChanged=false, lastProg="";
var tipCount=0, sharedApp=null;
var g_debugParams="", fix=1, dirty=false;
var isWebIDE=false; imgGrad = null;
var ignoreIcons=false, isSample = false;
var sharedFiles, sharedText, startedByShare;
var plgApk=null, playStore=null, purchases=[];
var pluginVersions=[];
var g_test=false;

//Called when application is started.
function OnStart()
{
	app.ShowProgress("");
	
    //Load settings.
	textSize = app.LoadNumber( "TextSize", 12 ); 
	
    //Get app name and path.
    appName = app.GetName();
    appPath = "/sdcard/" + appName;
     
    //Extract editor to private folder if not done.
    if( app.IsNewVersion() ) 
    {
        //var editDir = app.GetPrivateFolder( "edit" );
        var editDir = appPath+"/.edit";
        app.ExtractAssets( "edit", editDir, true );
    }
    
	//Delete demo and temp folders.
	app.DeleteFolder( appPath+"/~demo" );
	tempFldr = "/sdcard/.DroidScript/Temp";
	app.DeleteFolder( tempFldr );
	app.MakeFolder( tempFldr );
    
    //Lock screen orientation to Portrait at startup.
    startOrient = app.GetOrientation(); 
    app.SetOrientation( "Portrait" );
    orient = app.GetOrientation(); 
    
    //Get screen dimensions.
    sw = app.GetScreenWidth();
    sh = app.GetScreenHeight();
    dens = app.GetScreenDensity();
    tablet = ( (sw > 1200 || sh > 1200) && dens < 320 );
    lowRes = ( sw < 800 && sh < 800 );
    
    //Get display dimensions.
    dw = app.GetDisplayWidth();
    dh = app.GetDisplayHeight();
    
    //Set appropriate default text size.
    if( app.IsTablet() && dens < 200 ) textSize = 13;

    //Set menus.
    menus = "New:Add.png,Connect:Connect.png,Exit:Exit.png"; 
    SetMenus( menus, "/assets/Img" );      
    
    //Disable normal back key functionality 
    //(unless we are launched from another app).
    //if( !sharedFiles && !sharedText )
        app.EnableBackKey( false );
    
    //Register for error broadcasts.
    app.SetOnBroadcast( app_OnBroadcast );
    
    //Create the main graphical layout.
    CreateLayout();        
    
    //Unlock orientation.
    app.SetOrientation( "" );
		
	//Check for plugin licenses.
    CheckLicenses();   	
    
    //Check for updates.
    CheckForUpdates();
    
    app.HideProgress();
}

//Called when shared data is received.
function OnData( isStartUp )
{
	//Check for any shared files from other apps
    //and pass on to user's programs.
    sharedFiles = app.GetSharedFiles();
    sharedText = app.GetSharedText();
    app.SaveText( "_SharedFiles", sharedFiles, "spremote" );
    app.SaveText( "_SharedText", sharedText, "spremote" );
    
    //Handle spk files.
    if( sharedFiles && sharedFiles[0].indexOf(".spk")>-1 ) 
    {
		spkFile = sharedFiles[0];
		spkTitle = spkFile.substr( spkFile.lastIndexOf("/")+1 );
		var s = spkTitle;
		if( s=="download.spk" ) s = "this package";
		var installDiag = app.CreateYesNoDialog( "Script Package Installer:\n\nDo you trust the source of "+s+"?" );
		installDiag.SetOnTouch( installDiag_OnTouch );
    }
	//Check if we need to auto-launch user app.
    else if( sharedFiles || sharedText ) {
        sharedApp = app.LoadText( "_SharedApp", null, "spremote" );
        if( sharedApp ) 
        { 
			startedByShare = isStartUp;
            LaunchApp( sharedApp );
        }
    }
}

//Called when back button is pressed.
function OnBack()
{
     if( layDoc.GetVisibility()=="Show" ) {
        if( app.GetData("CurWebDoc")=="Documentation" ) btnDocs_OnTouch();
        else webDocs.Back();
     }
     else if( laySamp.GetVisibility()=="Show" ) 
     {
         if( layEditSamp.GetVisibility()=="Show" ) layEditSamp.SetVisibility( "Hide" );
         else btnSamp_OnTouch();
     }
     else if( layEdit.GetVisibility()=="Show" ) 
     { 
        //Save user's changes.
		SaveCode();

        //Animate flip and stop timer.
        layFlip.Animate( "Flip", "" );    
        clearTimeout( timer );
     }
     else {
		//if( !sharedFiles && !sharedText ) {
			var yesNo = app.CreateYesNoDialog( "Exit DroidScript?" );
			yesNo.SetOnTouch( yesNoExit_OnTouch );
		//}
     }
}

//Called when application is paused.
function OnPause() 
{ 
}

//Called when application is resumed.
function OnResume() 
{ 
    if( sharedApp && startedByShare ) app.Exit();
}

//Handle Exit app choice.
function yesNoExit_OnTouch( result )
{
    if( result=="Yes" ) app.Exit();
}

//Handle spk installs.
function installDiag_OnTouch( result )
{
	if( result=="Yes" ) CheckPackage( spkFile );
	else app.ShowPopup( "Package rejected" );
}

//Set spacing of title and margins.
function SetTitleMargins()
{
    var left,right,top,bottom,width,height;
    
    //Set title image size and margins.
    if( orient=="Portrait" ) { 
        width = (tablet?0.052:0.07); height = (lowRes?0.05:(tablet?0.033:0.039));
        left = (tablet?0.28:0.21);  right = (tablet?0.28:0.21);
        top = (lowRes?0.018:(tablet?0.012:0.014));  bottom = (lowRes?0.018:(tablet?0.012:0.014));
        if( tablet ) scale=0.63; else scale=0.24;
    }
    else {
        width = (tablet?0.032:0.04); height = (lowRes?0.05:(tablet?0.046:0.07));
        left = (tablet?0.46:0.340);  right = (tablet?0.46:0.340);
        top = (lowRes?0.028:(tablet?0.022:0.025));  bottom = (lowRes?0.028:(tablet?0.022:0.025));
        if( tablet ) scale=0.63; else scale=0.72;
    }
    imgTitle.SetSize( width, height );
    
    imgTitle.SetMargins( left*scale,top,right*scale,bottom );
    
    //Set title button sizes.
    if( orient=="Portrait" ) { width = (tablet?0.16:0.23);  height = (tablet?0.040:0.055);  }
    else { width = (tablet?0.1:0.13);  height = (tablet?0.065:0.100);  }
    btnDocs.SetSize( width, height );
    btnSamp.SetSize( width, height );
}

//Re-set spacings and sizes of controls.
function AdjustLayout()
{
    var left,right,top,bottom,width,height;
    
    //Set samples and docs top padding (so we can see title bar).
    if( orient=="Portrait" ) top = (lowRes?0.104:(tablet?0.066:0.080));
    else top = (lowRes?0.104:(tablet?0.104:0.142));
    laySamp.SetPadding( 0, top, 0, 0 );
    layDoc.SetPadding( 0, top, 0, 0 );
    
    //Reset programs list and gradient cover layer size.
    width = 1.0; height = 0.94;
    //lst.SetSize( width, height );
    //lst.SetPadding( (tablet?0.2:0.12), 0.01, (tablet?0.2:0.12), 0.01 );
    imgGrad.SetSize( width, height );
    
    //Reset code editor dimensions.
    if( orient=="Portrait" ) height = (lowRes?0.83:(tablet?0.88:0.86));
    else height = (lowRes?0.83:(tablet?0.81:0.76));
    scrollEdit.SetSize( 1.0, height );
    if( orient=="Portrait" ) edit.SetSize( 1.5, -1 );
    else edit.SetSize( 1.0, -1 );
    
    //Set code edtor button height.
    if( orient=="Portrait" ) height = (tablet?0.044:0.052);
    else height = (tablet?0.066:0.082);
    btnUndo.SetSize( 0.18, height );
    btnRedo.SetSize( 0.18, height );
    btnDbg.SetSize( 0.22, height );
    btnExec.SetSize( 0.22, height );
    
    //Reset sample editor dimensions.
    if( orient=="Portrait" ) height = (lowRes?0.83:(tablet?0.88:0.86));
    else height = (lowRes?0.83:(tablet?0.81:0.76));
    scroll.SetSize( 1.0, height );
    if( orient=="Portrait" ) editSamp.SetSize( 1.5, -1 );
    else editSamp.SetSize( 1.0, -1 );
    
    //Set sample edtor button height.
    if( orient=="Portrait" ) height = (tablet?0.044:0.052);
    else height = (tablet?0.066:0.082);
    btnCopy.SetSize( 0.26, height );
    btnRun.SetSize( 0.26, height );
    
    //Set documentation size.
    if( orient=="Portrait" ) webDocs.SetSize( 1.0, (lowRes?0.83:0.94) );
    else webDocs.SetSize( 1.0, (lowRes?0.83:0.86) );
}

//Called when configuration changes.
function OnConfig() 
{           
    //Get new orientation.
    orient = app.GetOrientation();  

	//Calculate scaling val to keep objects same size.
	if( orient=="Portrait"  ) fix = 1;
	else fix = dw/dh;
	
    //Re-position controls.    
    SetTitleMargins();
    AdjustLayout();
    
    //Draw icons ( but first time).
    //if( !ignoreIcons ) 
    ShowIcons();
    ignoreIcons = false;
}

//Handle wifi connect button.
function btnConnect_OnTouch()
{
    HandleMenu( "Connect" );
}

//Set menus.
function SetMenus( list, images )
{
    //Do nothing.
    //app.SetMenu( list );
}

//Handle custom menu.
function lstMenu_OnTouch( item )
{
    btnMenu_OnTouch();
    HandleMenu( item );
}

//Called when user selects a menu item.
function OnMenu( name )
{  
    if( name==null ) btnMenu_OnTouch();
    //HandleMenu( name );
}

//Called when user selects a menu item.
function HandleMenu( name )
{      
    if( name=="New" ) {
        ShowTextDialog( "New Program", "", "OnAdd" );
    }
    else if( name=="Connect" ) 
    {
        var ip = app.GetIPAddress();
        if( ip == "0.0.0.0" ) { app.ShowPopup( "Please Enable Wi-Fi" ); return; }
        
        app.Alert( "To edit programs using your PC, type the following" + 
            " address into your web browser's address bar:\n\n" + ip+":8088", "Wi-Fi Connect" );

        app.StartDebugServer();
        btnConnect.SetTextColor("#97C024");
    }
    else if( name=="Exit" ) {
        app.Exit( true );   
    }
    else if( name=="About" ) {
        ShowAbout();
    }
    else if( name=="Settings" ) {
        ShowSettings();
    }
    else if( name=="Plugins" ) {
        ShowPlugins();
    }
    else if( name=="Test" ) {
        app.Debug("USB"); 
    }
}

//Show custom slide out menu.
function btnMenu_OnTouch()
{
    //app.ShowMenu();
    //return;
    
    if( layMenu.GetVisibility()=="Hide" )
        layMenu.Animate( "ScaleFromTop" );
    else 
        layMenu.Animate( "ScaleToTop" );
}

//Create the graphical layout.
function CreateLayout()
{
    //Remove old layouts if they exist.
    if( layFront ) app.RemoveLayout( layFront );
    if( laySamp ) app.RemoveLayout( laySamp );
    if( layDoc ) app.RemoveLayout( layDoc );
        
    //--- Main Screen ----------

    //Create main layout for buttons etc.
    layFront = app.CreateLayout( "linear", "vertical,fillxy,touchthrough" );    

    //Create title bar and buttons.
    layBar = app.CreateLayout( "Linear", "horizontal,vcenter,fillx" );    
    layBar.SetBackground( "/res/drawable/bar_gray" );
    btnDocs = app.CreateButton( "Docs", (tablet?0.16:0.23), (tablet?0.038:0.04), "bar-gray" );
    btnDocs.SetOnTouch( btnDocs_OnTouch );
    btnDocs.SetTextColor("#dddddd");
    layBar.AddChild( btnDocs );
    
    btnConnect = app.CreateButton( "\u21e7", (tablet?0.08:0.13), (tablet?0.040:0.04), "bar-gray" );
    btnConnect.SetOnTouch( btnConnect_OnTouch );
    btnConnect.SetMargins(0.02,0,0,0);
    btnConnect.SetTextSize("12");
    btnConnect.SetTextColor("#999999");
    layBar.AddChild( btnConnect );
    
    imgTitle = app.CreateImage( "/assets/Img/AScript.png", (tablet?0.052:0.07), (lowRes?0.05:(tablet?0.033:0.039)), "" );
    layBar.AddChild( imgTitle );
    
    btnMenu = app.CreateButton( "...", (tablet?0.08:0.13), (tablet?0.040:0.04), "bar-gray" );
    btnMenu.SetOnTouch( btnMenu_OnTouch );
    btnMenu.SetMargins(0,0,0.04,0);
    btnMenu.SetTextSize("16");
    btnMenu.SetTextColor("#dddddd");
    btnMenu.SetPadding(0,0,0,0.014);
    layBar.AddChild( btnMenu );
    
    btnSamp = app.CreateButton( "Samples", (tablet?0.16:0.23), (tablet?0.038:0.04), "bar-gray" );
    btnSamp.SetOnTouch( btnSamp_OnTouch );
    btnSamp.SetTextColor("#dddddd");
    layBar.AddChild( btnSamp );
    layFront.AddChild( layBar );
    SetTitleMargins();
    
    //Create layout to allow flipping of list/code.
    layFlip = app.CreateLayout( "Frame", "" );
    
    //Create TextEdit control to edit code (invisible at first).
    layEdit = app.CreateLayout( "Linear", "Vertical,FillXY" );
    layEdit.SetVisibility( "Hide" );
    scrollEdit = app.CreateScroller( 1.0, (lowRes?0.83:(tablet?0.88:0.86)), "" );
    edit = app.CreateTextEdit( "", 1.5, -1, "Left,NoSpell" );
    edit.SetBackColor( "#ffffffff" );
    edit.SetTextColor( "#ff444444" );
    edit.SetTextSize( textSize );
    edit.SetPadding( 0.04,0.02,0.1,0.5 ); //<-needed for keyboard space.
    edit.SetOnChange( edit_OnChange );
    scrollEdit.AddChild( edit );
    layEdit.AddChild( scrollEdit );
    
    //Create editing buttons.
    layEditBtns = app.CreateLayout( "Linear", "Horizontal,VCenter,FillX" );
    layEditBtns.SetPadding( 0,0.006,0,0.006 );
    layEditBtns.SetBackColor( "#ff777777" );
    
    btnUndo = app.CreateButton( "Undo", 0.18, (tablet?0.04:0.06), "gray" );
    btnUndo.SetOnTouch( btnUndo_OnTouch );
    layEditBtns.AddChild( btnUndo );
    
    btnDbg = app.CreateButton( "Debug", 0.22, (tablet?0.04:0.06), "gray" );
    btnDbg.SetMargins( 0.06,0,0.04,0 );
    btnDbg.SetOnTouch( btnDbg_OnTouch );
    layEditBtns.AddChild( btnDbg );
    
    btnExec = app.CreateButton( "Run", 0.22, (tablet?0.04:0.06), "gray" );
    btnExec.SetMargins( 0,0,0.06,0 );
    btnExec.SetOnTouch( btnExec_OnTouch );
    layEditBtns.AddChild( btnExec );
   
    btnRedo = app.CreateButton( "Redo", 0.18, (tablet?0.04:0.06), "gray" );
    btnRedo.SetOnTouch( btnRedo_OnTouch );
    layEditBtns.AddChild( btnRedo );
    
    layEdit.AddChild( layEditBtns );
    layFlip.AddChild( layEdit );
    
    //Create program list control.
    //var progList = GetProgramList();
    layLst = app.CreateLayout( "Frame", "FillXY" );
    if( appName=="IOIOScript" ) layLst.SetBackground( "/res/drawable/pattern_carbon", "repeat" );
    else if( appName=="NxtScript" ) layLst.SetBackground( "/assets/Img/Tile.png", "repeat" );
    else layLst.SetBackground( "/res/drawable/android" );    
    
    /*
    var btnClr = "GreenButton";
    if( appName=="IOIOScript" ) btnClr = "AlumButton";
    else if( appName=="NxtScript" ) btnClr = "OrangeButton";
    lst = app.CreateList( progList, 1.0, 0.93, "FillXY," + btnClr );    
    lst.SetPadding( (tablet?0.2:0.12), 0.01, (tablet?0.2:0.12), 0.01 ); 
    lst.SetTextMargins( 0, 0.01, 0, 0.01 ); 
    lst.SetTextColor1( "#fffefefe" );
    lst.SetOnTouch( lst_OnTouch );
    lst.SetOnLongTouch( lst_OnLongTouch );
    layLst.AddChild( lst );
    */
    
    //Show user's program icons if starting in portrait
    //mode, else it's done in OnConfig.
    if( startOrient=="Portrait" ) ShowIcons();
    //else ignoreIcons = true;
    
    //Create translucent gradient image above list.
    imgGrad = app.CreateImage( null, 1.0, 0.94, "" ); 
    //imgGrad.SetBackGradient( "#00000000", "#66000000" );
    imgGrad.SetBackGradientRadial( 0.5, 0.2, 2.0, "#00000000", "#88000000" );
    imgGrad.SetTouchable( false );
    layLst.AddChild( imgGrad );
    
    layFlip.AddChild( layLst );
    layFront.AddChild( layFlip );
    
    //--- Custom slide down options layout -----
    
    layMenus = app.CreateLayout( "Linear", "fillxy,touchthrough" );
    layMenu = app.CreateLayout( "Linear", "fillxy" );
    layMenu.SetMargins( 0.15, (tablet?0.065:0.076), 0,0 );
    layMenu.SetVisibility( "Hide" );
    layMenus.AddChild( layMenu );
    
    lstMenu = app.CreateList( "New,Settings,Plugins,About", 0.3, 0.25, "FillXY" );    
    lstMenu.SetPadding( 0,0.005,0,0,0 );
    lstMenu.SetBackColor( "#e4444444" );
    lstMenu.SetTextSize( 18 );
    lstMenu.SetOnTouch( lstMenu_OnTouch );
    layMenu.AddChild( lstMenu );
    
    //---  Samples Screen -------
    
    //Create an (initially invisible) layout to show samples.
    laySamp = app.CreateLayout( "Absolute", "fillxy,touchthrough" );
    laySamp.SetPadding( 0, (lowRes?0.104:(tablet?0.066:0.080)), 0, 0 ); 
    laySamp.SetVisibility( "Hide" );
    layExamp = app.CreateLayout( "Frame", "vertical,fillxy" );
    layExamp.SetBackColor( "#ff222222" );
    
    //Create list of samples.
    listArray = "Hello World:Shows an image and a popup message:x";
    listArray += ",Controls Demo:Shows how to use basic controls:x";
    listArray += ",Drawing Demo:Shows how to use drawing functions:x";
    listArray += ",Drawing Order:Shows how to change drawing order:x";
    listArray += ",Image Rotate:Demos image rotation:x";
    //todo listArray += ",Gallery:Photo gallery example:x";
    listArray += ",Layout Slide:Demos a page slide effect:x";
    listArray += ",Dialog ProgressBar:Shows how to use a progress bar dialog:x";
    listArray += ",Dialog Custom:Shows how to create custom dialogs:x";
    listArray += ",Tabs Demo:Shows how to use tabs:x";
    listArray += ",Icon Fonts:Uses FontAwesome to show icons:x";
    listArray += ",Text Formatting:Use HTML tags to format text:x";
    listArray += ",Scroller:Shows how to use a scroller:x";
    listArray += ",Tilt And Draw:Use accelerometer to draw:x";
    listArray += ",Location:Use GPS and/or network to find location:x";
    listArray += ",Notifications:Put messages in the notification drawer:x";
    listArray += ",Alarms:Set alarms to wake up your App:x";
    listArray += ",Orientation:Use digital compass to find orientation:x";
    listArray += ",Audio Output:Play a sound file:x";
    listArray += ",Audio Player:Simple audio player:x";
    listArray += ",Audio Record:Audio recording demo:x";
    listArray += ",Audio Signal:Signal generator:x";
    listArray += ",Audio Synth:Software synthesizer:x";
    listArray += ",Audio MIDI-Tune:Play a simple MIDI tune:x";
    listArray += ",Sound Board:Simple sound board demo:x";
    listArray += ",Speech Recognition:How to recognize speech:x";
    listArray += ",MediaStore:Query the media store for music:x";
    listArray += ",Video Player:Simple video player:x";
    listArray += ",Video Stream:Video streaming sample:x";
    listArray += ",Game Pong:Classic game demo:x";
    //listArray += ",Game Invaders:Simple invaders game:x";
    listArray += ",Game Bounce:Graphics performance demo:x";
    listArray += ",Game VScroll:Vertical scroller game template:x";
    listArray += ",Game HScroll:Horizontal scroller game template:x";
    listArray += ",Game Flappy:Flappy bird style game:x";
    listArray += ",GLView Simple:Basic fast 2d graphics demo:x";
    listArray += ",GLView SpriteSheet:Fast 2d sprite sheet demo:x";
    listArray += ",GLView Advanced:Fast 2d advanced demo:x";
    listArray += ",Text To Speech:Make your phone speak:x";
    listArray += ",Text Editor:Simple text editor:x";
    listArray += ",SMS:Send and receive text messages:x";
    listArray += ",Mail Share:Send email via an external App:x";
    listArray += ",Mail Send:Send email messages directly:x";
    listArray += ",Mail Receive:Receive email messages directly:x";
    listArray += ",Security Encryption:Encrypt and Decrypt text:x";
    listArray += ",Calculator:A simple calculator:x";
    listArray += ",HTML Viewer:Display local and remote web pages:x";
    if( appName!="NxtScript" ) listArray += ",HTML Gauges:Using the 'CanvGauge' HTML5 library:x";
    if( appName!="NxtScript" ) listArray += ",HTML Graphs:Using the 'jqPlot' HTML5 library:x";
    listArray += ",HTML Server:Run a web server on your phone:x";
    listArray += ",HTTP Get:Get data from a remote web server:x";
    listArray += ",Wifi Demo:Send commands to and from PC via Wifi:x";
    listArray += ",Camera Stream:Stream Video from camera to PC:x";
    listArray += ",Camera Snap:Take pictures and save to sdcard:x";
    listArray += ",Camera Motion:Detect motion and location in image:x";
    listArray += ",Camera Color:Detect pixel colors:x";
    //listArray += ",SmartWatch:Control programs with a Sony SmartWatch (PRO):x";
    //if( app.IsPro() ) listArray += ",SmartWatch Service:Write a Sony SmartWatch app (PRO):x";
    listArray += ",Shared Data:Receive text and files from other apps:x";
    listArray += ",App Events:Demos all available app events:x";
    listArray += ",USB Serial:Control USB serial devices using OTG cable:x";
    listArray += ",USB Espruino:Program Espruino boards with an OTG cable:x";
    listArray += ",Bluetooth Serial:Control Bluetooth serial port devices:x";
    listArray += ",Bluetooth LEDs:Control tri-color LED strips via Bluetooth:x";
    
    if( appName!="IOIOScript" ) listArray += ",NXT Motors:Simple Lego Mindstorms motor control:x";
    if( appName!="IOIOScript" ) listArray += ",NXT Beep:Make the NXT play a tone:x";
    if( appName=="NxtScript" || app.IsPro()) listArray += ",NXT Joypad:Joypad NXT control:x"; 
    //fix it: if( appName=="NxtScript" || app.IsPro()) listArray += ",NXT Multipad:Multi-touch NXT control:x";
    if( appName!="IOIOScript" ) listArray += ",NXT Sensors:Reads NXT sensors:x";
    if( appName=="NxtScript" || app.IsPro()) listArray += ",NXT Mailbox:Access NXT mailboxes:x";
    if( appName=="NxtScript" || app.IsPro()) listArray += ",NXT MultiBrick:Control multiple NXT Bricks:x";
    if( appName=="NxtScript" || app.IsPro()) listArray += ",NXT Face:Draws a face which changes when tilted:x";
    if( appName=="NxtScript" || app.IsPro()) listArray += ",NXT Camera:Control your NXT from a PC and stream video:x";
    if( appName=="NxtScript" || app.IsPro()) listArray += ",NXT SmartWatch:Control your NXT with a Sony SmartWatch:x";
    
    lstSamp = app.CreateList( listArray, -1, -1, "FillXY,WhiteGrad" );    
    //lstSamp.SetMargins( 0.01, 0.014, 0.01, 0.006 ); 
    //lstSamp.SetPadding( 0.1, 0.05, 0.1, 0 ); 
    lstSamp.SetTextColor1( (appName=="NxtScript"?"#ffDC6B36":"#ff555558") );
    lstSamp.SetTextColor2( "#ff555558" );
    lstSamp.SetTextMargins( 0.04, 0, 0, 0 ); 
    lstSamp.SetOnTouch( lstSamp_OnTouch );
    lstSamp.SetOnLongTouch( lstSamp_OnLongTouch );
    layExamp.AddChild( lstSamp );
    
    //Save samples list for IDE.
    app.SaveText( "_Samples", listArray, "spremote" );
    
    //Create web control for sample docs.
    /*webSamp = app.CreateWeb( 1.0, 1.0, "" );
    //webSamp.LoadUrl( "file:///android_asset/Test.htm" );
    webSamp.SetVisibility( "Hide" );
    layExamp.AddChild( webSamp );
    */
    //Create text control showing code.
    layEditSamp = app.CreateLayout( "Linear", "Vertical,FillXY" );
    //layEditSamp.SetBackGradient( "#ff444444", "#ff222222" ); 
    layEditSamp.SetVisibility( "Hide" );
    scroll = app.CreateScroller( 1.0, (lowRes?0.83:(tablet?0.88:0.86)), "" );
    //scroll.SetBackGradient( "#ffffffff", "#ffdddddd" );
    editSamp = app.CreateTextEdit( "", 1.5, -1, "Left,ReadOnly" + (app.GetBuildNum()>7?",NoSpell,NoKeyboard":"") );
    //editSamp.SetBackGradient( "#fffefefe", "#ffdddddd" );
    editSamp.SetBackColor( "#ffffffff" );
    editSamp.SetTextColor( "#ff444444" );
    editSamp.SetTextSize( textSize );
    editSamp.SetPadding( 0.04,0.02,0.1,0.5 ); //<-needed for keyboard space.
    scroll.AddChild( editSamp );
    layEditSamp.AddChild( scroll );
    
    //Create horizontal layout for buttons.
    layBtns = app.CreateLayout( "Linear", "Horizontal,VCenter,FillX" );
    layBtns.SetBackColor( "#ff777777" );
    layBtns.SetPadding( 0,0.006,0,0.006 );
    
    //Create button to zoom out.
   // btnZoomOut = app.CreateButton( "-", 0.16, 0.05, "gray" );
   // btnZoomOut.SetOnTouch( btnZoomOut_OnTouch );
    //layBtns.AddChild( btnZoomOut );
    
    //Create button to copy sample.
    btnCopy = app.CreateButton( "Copy All", 0.26, (tablet?0.04:0.06), "gray" );
    btnCopy.SetMargins( 0.08,0,0.08,0 );
    btnCopy.SetOnTouch( btnCopy_OnTouch );
    layBtns.AddChild( btnCopy );
    
    //Create button to launch sample.
    btnRun = app.CreateButton( "Run", 0.26, (tablet?0.04:0.06), "gray" );
    btnRun.SetMargins( 0.08,0,0.08,0 );
    btnRun.SetOnTouch( btnRun_OnTouch );
    layBtns.AddChild( btnRun );
    
    //Create button to zoom in.
   // btnZoomIn = app.CreateButton( "+", 0.16, 0.05, "gray" );
   // btnZoomIn.SetOnTouch( btnZoomIn_OnTouch );
   // layBtns.AddChild( btnZoomIn );
  
    layEditSamp.AddChild( layBtns );
    layExamp.AddChild( layEditSamp );
    laySamp.AddChild( layExamp );
    
    //--- Documentation Screen -------
    
    //Create an (initially invisible) layout to show docs.
    layDoc = app.CreateLayout( "Absolute", "fillxy,touchthrough" );
    layDoc.SetPadding( 0, (lowRes?0.104:(tablet?0.066:0.080)), 0, 0 ); 
    layWeb = app.CreateLayout( "Linear", "vertical,fillxy" );
    layWeb.SetBackGradient( "#ffdddddd", "#ffaaaaaa" );
    layDoc.SetVisibility( "Hide" );
    
    webDocs = app.CreateWebView( 1.0, (lowRes?0.83:0.94), "NoLongTouch" );
    webDocs.LoadUrl( "file:///android_asset/edit/docs/Docs.htm" );
    layWeb.AddChild( webDocs );
    layDoc.AddChild( layWeb );
    
    //---------------------------------
    
    //Adjust layout according to orientation.
    AdjustLayout();
    
    //Hide main layout if required.
    if( sharedApp ) layFront.SetVisibility("Hide");
    
    //Add main layouts to app.    
    app.AddLayout( layFront );
    app.AddLayout( laySamp );    
    app.AddLayout( layDoc );    
    app.AddLayout( layMenus );
}

//Create icon layout to show user's programs.
function ShowIcons()
{
    //Remove current icon layout (and free old objects).
    if( scrollIcons ) layLst.DestroyChild( scrollIcons );
    
    //Create scroller.
    scrollIcons = app.CreateScroller();
    
    //Create icon layout.
    layIcons = app.CreateLayout( "Linear", "FillXY,Left" );
    layIcons.SetPadding(0,0.02,0,0);
    scrollIcons.AddChild( layIcons );
    
    //Get list of user's programs.
    var progList = GetProgramList().split(",");
    
    //Set icons per row count.
    var iconsPerRow = 4;
    if( orient=="Landscape" ) { iconsPerRow = 7; }
    var iconW = 0.76/(iconsPerRow);
     
    //Create an icon for each program.
    for( var i=0; i<progList.length && progList[0]!=""; i++ )
    {
        if( i%iconsPerRow==0 ) {
            layIconsHoriz = app.CreateLayout( "Linear", "Horizontal" );
            layIcons.AddChild( layIconsHoriz );
        }
        //Create icon/text layout.
        var layIcon = app.CreateLayout( "Linear", "Vertical" );
        layIcon.SetMargins( 0.082/iconsPerRow, 0, 0.082/iconsPerRow, 0 );
        layIconsHoriz.AddChild( layIcon );
        
        //Get program icon.
        var file = appPath+"/"+progList[i]+"/Img/"+progList[i]+".png";
        if( !app.FileExists( file ) ) file = "/assets/Img/Icon.png";
        
        //Create icon image.
        var imgIcon = app.CreateImage( file, iconW, -1, "Square" ); 
        if( !imgIcon ) imgIcon = app.CreateImage( "/assets/Img/Icon.png", iconW, -1 ); 
        imgIcon.SetName( progList[i] );
        imgIcon.SetOnTouchUp( lst_OnTouchUp );
        imgIcon.SetOnTouchDown( lst_OnTouchDown );
        imgIcon.SetOnLongTouch( lst_OnLongTouch );
        layIcon.AddChild( imgIcon );
        
        //Create text label.
        var txtIcon = app.CreateText( progList[i], iconW*1.1, 0.065/fix, "Multiline" );
        txtIcon.SetTextSize( 14 );
        txtIcon.SetTextColor( "#ff666666" );
        layIcon.AddChild( txtIcon );
    }
    
    layLst.AddChild( scrollIcons );
    
    //Remove and re-add grad (so it does not get covered up).
    if( imgGrad ) {
		layLst.RemoveChild( imgGrad );
		layLst.AddChild( imgGrad );
    }
}


//Get user program list (excluding folders with ~ char at start).
function GetProgramList()
{
    //Get old type of app.
    //var progList = app.ListFolder( appPath, ".js" ).toString();
    //progList = progList.replace( RegExp("~.*?.js,*","gim"), "" );
    //progList = progList.replace( RegExp(appName+".js,*","gim"), "" );
    //progList = progList.replace( RegExp(".js","gim"), "" ); 
    
    //Get new types of app.
    var progList = "";
    var list = app.ListFolder( appPath,"",0,"alphasort");
    for( var i=0; i<list.length; i++ )
    {
        if( list[i].substr(0,1)!="~" )
        {
            if( app.FileExists( appPath+"/"+list[i]+"/"+list[i]+".js" ) ) {
                if( progList.length>0 ) progList += ",";
                progList += list[i];
            }
        }
    }
    return progList;
}

//Handle program selection.
function lst_OnTouchDown( e )
{
    imgTouchedIcon = app.GetLastImage();
    imgTouchedIcon.SetAlpha( 0.6 );
    setTimeout( "imgTouchedIcon.SetAlpha( 1.0 )", 1000 );
}

//Handle program selection.
function lst_OnTouchUp( e )
{
    var img = app.GetLastImage();
    img.SetAlpha( 1.0 );
    
    //Get program name.
    //item = item.split(":")[0];
    //curProgam = item;
    //curProgam = e.source;

    //Make sure we have shut down previous program's process.
    //(Prevents script caching)
    //var pid = app.GetData( "PID" );
    //if( pid ) app.KillApp( pid );
    //if( pid ) app.StopApp("");
    
    //Check for smartwatch services.
    if( e.source.GetName().substr(0,3).toLowerCase()=="sws" )
    {
        app.Alert( "SmartWatch service apps can only be started from a Smart Watch!" );
        return;
    }
    
    //Execute program.
    isWebIDE = false;
    LaunchApp( e.source.GetName() );
    
    //Save last app.
    app.SaveText( "_LastApp", e.source.GetName(), "spremote" );
}

//Execute program in it's own process.
function LaunchApp( name )
{
    curProgam = name;
    isSample = false;
    app.StartApp( appPath+"/"+name+"/"+name+".js", g_debugParams );
}

//Handle broadcast msg from user's app (errors etc).
function app_OnBroadcast( type, msg )
{
    if( type=="ShowError" && !isSample && !isWebIDE ) 
    {
        //Prevent auto-close of app.
        if( sharedApp ) { 
            sharedApp = null;
            layFront.SetVisibility("Show");
        }
        //Get message.
        msg = msg.split("|");
        var line = parseInt(msg[1])-1;
        //app.Alert( msg[1] );
        
        //Detect errors on app.js (ie. OnStart not defined etc).
        if( msg[2].indexOf("app.js")>-1 || msg[2].indexOf("nxt.js")>-1
			|| msg[2].indexOf("tabs.js")>-1 ) line = -1;
        
        //Re-load code.
        var code = app.ReadFile( appPath+"/"+curProgam+"/"+curProgam+".js" );
        if( code==null ) return;
        
        //Set comment colours etc.
        code = SetColours( code );
        
        //Open editor.
        if( layEdit.GetVisibility()!="Show" ) 
            lstOps_Select( "Edit", "NoSetCols" )
        
        //Search for line.
        var lines = code.split( "<br>" );
        if( lines && line > -1 ) 
        { 
            //app.Alert( lines[1] );
            //Colour errors red.
            var s1="",s2="";
            for( i=0; i<line; i++ ) s1 += lines[i] + "<br>";
            for( i=line+1; i<lines.length; i++ ) s2 += lines[i] + "<br>";
            code = s1 + "<font face='Arial' color='red' bgcolor='red'>" + lines[line] + "</font><br>" + s2;
            edit.SetHtml( code );
            
            //Set cursor to error line.
            var charPos = edit.GetLineStart( line );
            edit.SetCursorPos( charPos );
            var y = edit.GetLineTop( line ) - 0.5; //sh/2;
            setTimeout( "scrollEdit.ScrollTo( 0, "+y+" )", 100 );
            textChanged = false;
        }
    }
}

//Handle program long press.
function lst_OnLongTouch( e )
{
    var img = app.GetLastImage();
    img.SetAlpha( 1.0 );
    
    //Get program name.
    //item = item.split(":")[0];
    curProgam = e.source.GetName();

    //Show options dialog.
    var sOps = "Edit,Rename,Delete,Create Shortcut,Share via Email,Build APK" 
    //sOps += (app.IsPro() ? ",Build APK" : "" );
    lstOps = app.CreateListDialog( "Actions", sOps, "" );
    lstOps.SetOnTouch( lstOps_Select ); 
}

//Called when program long click option chosen.
function lstOps_Select( item, noSetCols )
{
    if( item=="Edit" )
    {
        //Load sample code.
        var txt = app.ReadFile( appPath+"/"+curProgam+"/"+curProgam+".js" );
        
         //Convert tabs to spaces.
        txt = txt.replace( RegExp( "\\t","gim"), "    " );
        //txt = txt.replace( RegExp( " ","gim"), "&nbsp;" );
        
        //Colour comments and convert newline chars.
        txt = SetColours( txt );
        //txt = txt.replace( RegExp("((^|\\s)//.*?)$","gim"), "<font face='Arial' color='#008800'>$1</font>" );
        //txt = txt.replace( RegExp( "\\n","gim"), "<br>" );
        edit.SetHtml( txt );
        
        //Clear history if program has changed.
        if( lastProg!=curProgam ) edit.ClearHistory();
        lastProg = curProgam;
        
        //Animate flip and start change watch timer.
        layFlip.Animate( "Flip" );    
        //if( noSetCols!="NoSetCols" ) setTimeout( "SetEditorColours()", 500 );
        timer = setTimeout( "CheckForChanges()", 1000 );
        
        if( tipCount++ < 4 ) app.ShowPopup( "Press Back to exit editor", "Short" );
    }
    else if( item=="Rename" ) {
        ShowTextDialog( "Rename Program", curProgam, "OnRename" );
    }
    else if( item=="Delete" ) 
    {
        yesNo = app.CreateYesNoDialog( "Are you sure you want to delete program '" + curProgam + "' ?" );
        yesNo.SetOnTouch( yesNoDelete_OnTouch );
    }
    else if( item=="Create Shortcut" )
    {
		var file = appPath+"/"+curProgam+"/Img/"+curProgam+".png";
		if( !app.FileExists( file ) ) file = "/assets/Img/Icon.png";
        app.CreateShortcut( curProgam, file, appPath+"/"+curProgam+"/"+curProgam+".js" );
    }
    else if( item=="Share via Email" )
    {
		CreatePackage( curProgam );
		//var file = appPath+"/"+curProgam+".spk";
		var file = tempFldr+"/"+curProgam+".spk";
		app.SendMail( "", "DroidScript-"+curProgam, "Check out my awesome DroidScript App!\n\nwww.droidscript.org", file );
    }
    else if( item=="Build APK" )
    {
		var privDir = app.GetPrivateFolder( "Plugins" );
        var plgFile = privDir+"/apkbuilder/ApkBuilder.jar";
        if( app.FileExists(plgFile) && purchases["plugin_apkbuilder"] )
            ShowAPKDialog();
        else 
            app.Alert( "The 'ApkBuilder' plugin is required for building" +
                " APKs.  You can download this plugin from the " +
                "'Plugins' menu.", "Build APK" );
    }
}

//Handle delete 'are you sure' dialog.
function yesNoDelete_OnTouch( result )
{
    if( result=="Yes" ) {
        //Delete the file and refresh list.
        app.DeleteFolder( appPath+"/" + curProgam );
        //lst.SetList( GetProgramList(), "," );
        ShowIcons();
    }
}

//Called after user enters renamed program.
function OnRename( name )
{
    //Check if already exists.
    var file = appPath+"/"+curProgam+"/"+name+".js";
    if( app.FileExists( file ) ) {
        app.Alert( "Program already exists!" );
    }
    else {
        //Rename the file and fldr and refresh list.
        app.RenameFile(  appPath+"/"+curProgam+"/"+curProgam+".js", file );
        app.RenameFile( appPath+"/"+curProgam, appPath+"/"+name );
        ShowIcons();
    }
}

//Called after user enters new program name.
function OnAdd( name )
{
    var fldr = appPath+"/"+name;
    if( app.FolderExists( fldr ) ) {
        app.Alert( "App already exists!" );
    }
    else {
        app.MakeFolder( fldr );
        //app.MakeFolder( fldr+"/Img" );
        //app.MakeFolder( fldr+"/Snd" );
        //app.MakeFolder( fldr+"/Html" );
        var prog = app.ReadFile( "/assets/samples/Template.js" );
        app.WriteFile( fldr+"/"+name+".js", prog );
        
        //Refresh list.
        //lst.SetList( GetProgramList(), "," );
        ShowIcons();
    }
}

//Handle code changes.
function edit_OnChange()
{
    textChanged = true;
    dirty = true;
}

//Check for change in current line posn.
function CheckForChanges()
{
    if( textChanged ) {
        var line = edit.GetCursorLine();
        if( lastLine != line ) SetEditorColours();
        lastLine = line;
    }
    timer = setTimeout( "CheckForChanges()", 500 );
}

//Do syntax highlighting in editor.
function SetEditorColours()
{
    var txt = edit.GetText();
	txt = SetColours( txt );
    edit.SetHtml( txt );
    textChanged = false;
}

//Do syntax highlighting on a string.
//(also replace newlines with page breaks etc)
function SetColours( txt )
{
	txt = txt.replace( RegExp( "&","gim"), "&amp;" );
	txt = txt.replace( RegExp( "<","gim"), "&lt;" );
    txt = txt.replace( RegExp( ">","gim"), "&gt;" );
    txt = txt.replace( RegExp( " ","gim"), "&nbsp;" );
    txt = txt.replace( RegExp("(//.*?)$","gim"), "<font face='Arial' color='#008800'>$1</font>" );
    txt = txt.replace( RegExp( "\\n","gim"), "<br>" );
	return txt;
}
 
//Save user's changes if dirty flag set.
function SaveCode()
{
	if( dirty ) {
		var txt = edit.GetText();
		txt = txt.replace( RegExp( "\u00A0","gim"), " " ); //Replace nbsp with normal space.
		app.WriteFile( appPath+"/"+curProgam+"/"+curProgam+".js", txt );
		dirty = false;
    }
}

//Handle run button during code edit.
function btnExec_OnTouch()
{
	//Save user's changes.
	SaveCode();
	
    //Execute sample program in it's own process.
    isSample = false;
    isWebIDE = false;
    app.StartApp( appPath+"/"+curProgam+"/"+curProgam+".js", "remote" );    
}

//Handle debug button during code edit.
function btnDbg_OnTouch()
{
    //Save user's changes.
	SaveCode();
	
    //Execute sample program in it's own process.
    isSample = false;
    isWebIDE = false;
    app.StartApp( appPath+"/"+curProgam+"/"+curProgam+".js", "debug" );    
}

//Handle undo key.
function btnUndo_OnTouch()
{
    edit.Undo();
}

//Handle redo key.
function btnRedo_OnTouch()
{
    edit.Redo();
}


//Handle Docs button press.
function btnDocs_OnTouch()
{
    app.Vibrate( "0,10" );
    app.HideKeyboard( true );
    
    if( laySamp.GetVisibility()=="Show" )  {
        laySamp.Animate( "SlideToRight", OnDoneAnimate );
        btnSamp.SetText( "Samples" );
    }        
    
    if( layDoc.GetVisibility()=="Hide" ) { 
        layDoc.Animate( "SlideFromLeft", OnDoneAnimate );
        btnDocs.SetText( "<<" );
        SetMenus( "Exit:Exit.png", "/assets/Img" );
    }
    else {
        layDoc.Animate( "SlideToLeft", OnDoneAnimate );    
        btnDocs.SetText( "Docs" );
        SetMenus( "New:Add.png,Connect:Connect.png,Exit:Exit.png", "/assets/Img" );
    }        
}
 
//Handle Samples button press.
function btnSamp_OnTouch()
{
    app.Vibrate( "0,10" );
    app.HideKeyboard( true );
    
    if( layDoc.GetVisibility()=="Show" ) {
        layDoc.Animate( "SlideToLeft", OnDoneAnimate );    
        btnDocs.SetText( "Docs" );
    }       
    
    if( laySamp.GetVisibility()=="Hide" ) { 
        laySamp.Animate( "SlideFromRight", OnDoneAnimate );  
        btnSamp.SetText( ">>" ); 
        SetMenus( "Exit:Exit.png", "/assets/Img" );      
    }
    else {
        laySamp.Animate( "SlideToRight", OnDoneAnimate );
        btnSamp.SetText( "Samples" );
        SetMenus( "New:Add.png,Connect:Connect.png,Exit:Exit.png", "/assets/Img" );
    }            
}

//Called when animation is finished.
function OnDoneAnimate( type )
{
    //if( type=="SlideFromLeft" ) layDoc.SetVisibility( "Show" );
    //else if( type=="SlideToLeft" ) layDoc.SetVisibility( "Hide" );
    //else if( type=="SlideFromRight" ) laySamp.SetVisibility( "Show" );
    //else laySamp.SetVisibility( "Hide" );
}    

//Called when samples list item is selected.   
function lstSamp_OnTouch( item )
{
    //Get item name.
    curSample = item.split(":")[0];
    
    //Remote IOIO bit on front.
    curSample = curSample.replace( RegExp( "IOIO ","gim"), "" );
        
    //Replace spaces with underscores (for ICS assets).
    curSample = curSample.replace( RegExp( " ","gim"), "_" );
    
    //Load sample code.
    sampCode = app.ReadFile( "/assets/samples/" + curSample + ".js" );
    //sampCode = sampCode.replace( RegExp( "<","gim"), "<" );
    //sampCode = sampCode.replace( RegExp("((^|\\s)//.*?)$","gim"), "<font face='Arial' color='#008800'>$1</font>" );
    //sampCode = sampCode.replace( RegExp( "\\n","gim"), "<br>" );
    sampCode = SetColours( sampCode );
    editSamp.SetHtml( sampCode );
    
    layEditSamp.SetVisibility( "Show" );
    
    if( tipCount++ < 4 ) app.ShowPopup( "Press Back to return to list", "Short" );
}
   
//Called when samples list item is long pressed.   
function lstSamp_OnLongTouch( item )
{
}

//Handle running of samples.
function btnRun_OnTouch()
{
    //Execute sample program in it's own process.
    isSample = true;
    app.StartApp( "/assets/samples/"+curSample+".js", "remote" );
}

//Handle copy of samples.
function btnCopy_OnTouch()
{
    app.SetClipboardText( editSamp.GetText() );
    app.ShowPopup( "Text copied to clipboard" );
}

//Handle code zoom in button.
function btnZoomIn_OnTouch()
{
    if( textSize <= 18 ) textSize += 2;
    editSamp.SetTextSize( textSize );
}

//Handle code zoom out button.
function btnZoomOut_OnTouch()
{
    if( textSize >= 10 ) textSize -= 2;
    editSamp.SetTextSize( textSize );
}

//Show the settings dialog.
function ShowSettings()
{
    //Create dialog window.
    dlgSet = app.CreateDialog( "Settings");
    laySet = app.CreateLayout( "linear", "vertical,Center,FillXY" );
    //laySet.SetPadding( 0.2, 0.02, 0.2, 0.02 );
    //laySet.SetSize( 0.8, 0.25 );

    //Create text size spinner.
    txtSet = app.CreateText( "Font Size" );
    txtSet.SetMargins( 0.15, 0.01, 0.15, 0 );
	laySet.AddChild( txtSet );
	spTextSize = app.CreateSpinner( "6,7,8,9,10,11,12,13,14,15,16,18" );
	//spTextSize.SetSize( 0.3, -1 );
	spTextSize.SetText( textSize );
	laySet.AddChild( spTextSize );

    //Create OK and Cancel buttons.
    laySet2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    laySet2.SetMargins( 0, 0.02, 0, 0.01 );  
    btnSetOK = app.CreateButton( "OK", 0.2 );
    btnSetOK.SetOnTouch( btnSetOK_OnTouch );
    laySet2.AddChild( btnSetOK );
    btnSetCancel = app.CreateButton( "Cancel", 0.2 );
    btnSetCancel.SetOnTouch( btnSetCancel_OnTouch );
    laySet2.AddChild( btnSetCancel );
    laySet.AddChild( laySet2 );

    //Add dialog layout and show dialog.
    dlgSet.AddLayout( laySet );
    dlgSet.Show();
}

//Handle settings 'OK' click.
function btnSetOK_OnTouch()
{
    //Save settings.
	textSize = parseInt(spTextSize.GetText());
	app.SaveNumber( "TextSize", textSize ); 
	edit.SetTextSize( textSize );
	editSamp.SetTextSize( textSize );
	
    //Remove dialog.
    dlgSet.Dismiss();
}

//Handle settings 'Cancel' click.
function btnSetCancel_OnTouch()
{
    dlgSet.Dismiss();
}


//Generic text input dialog function.
function ShowTextDialog( title, deflt, callback )
{
    _dlgTxt = this;
    this.callback = callback;

    //Create dialog window.
    dlgTxt = app.CreateDialog( title );
    layTxtDlg = app.CreateLayout( "linear", "vertical,fillxy,left" );
    layTxtDlg.SetPadding( 0.01, 0, 0.01, 0 );

    //Create dialog controls.
    txtTxtDlg = app.CreateTextEdit( deflt, 0.6, -1, "Left" );
    txtTxtDlg.SetBackColor( "#ffffffff" );
    layTxtDlg.AddChild( txtTxtDlg );
    layTxtDlg2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    layTxtDlg2.SetMargins( 0, 0.02, 0, 0.01 );  
    btnTxtOK = app.CreateButton( "OK", 0.2, -1, "" );
    btnTxtOK.SetOnTouch( _dlgTxt_OnOk );
    layTxtDlg2.AddChild( btnTxtOK );
    btnTxtCancel = app.CreateButton( "Cancel", 0.2, -1, "" );
    btnTxtCancel.SetOnTouch( _dlgTxt_OnCancel );
    layTxtDlg2.AddChild( btnTxtCancel );
    layTxtDlg.AddChild( layTxtDlg2 );

    //Add dialog layout and show dialog.
    dlgTxt.AddLayout( layTxtDlg );
    dlgTxt.Show();
}

function _dlgTxt_OnCancel() { dlgTxt.Dismiss(); }

function _dlgTxt_OnOk() { 
    dlgTxt.Dismiss(); 
    var txt = txtTxtDlg.GetText();
    if( txt ) eval( _dlgTxt.callback + "(\"" + txtTxtDlg.GetText() + "\")" ); 
}


//Show about box.
function ShowAbout()
{
    //Create dialog window.
    dlgAbout = app.CreateDialog( "About DroidScript" );
    layAbout = app.CreateLayout( "linear", "vertical,fillxy" );
    layAbout.SetPadding( 0.2, 0, 0.2, 0.06 );

    //Create image at top.
    var img = app.CreateImage( "/Sys/Img/Icon.png", 0.2, -1, "" );
    img.SetMargins( 0, 0, 0, 0.02 );
    layAbout.AddChild( img );
    
    //Create text.
    var ver = app.GetVersion();
    var s = ( app.IsPro() ? "Version "+ver+" Beta Pro" : "Version "+ver+" Beta" );
    var txt = app.CreateText( s );
    txt.SetTextSize( 16 );
    txt.SetTextColor("#ffffff");
    layAbout.AddChild( txt );
    
    //Create forum link.
    var txtForum = app.CreateText( "" );
    txtForum.SetMargins( 0, 0.04, 0,0 );
    txtForum.SetTextSize( 16 );
    txtForum.SetTextColor("#56AEF2");
    txtForum.SetHtml( "<u>Discussion Group</u>" );
    txtForum.SetOnTouchDown( txtForum_OnTouchDown );
    layAbout.AddChild( txtForum );
    
    //Create twitter link.
    var txtTwitter = app.CreateText( "" );
    txtTwitter.SetMargins( 0, 0.04, 0,0 );
    txtTwitter.SetTextSize( 16 );
    txtTwitter.SetTextColor("#56AEF2");
    txtTwitter.SetHtml( "<u>Twitter</u>" );
    txtTwitter.SetOnTouchDown( txtTwitter_OnTouchDown );
    layAbout.AddChild( txtTwitter );
    
    //Create Facebook link.
    var txtFacebook = app.CreateText( "" );
    txtFacebook.SetMargins( 0, 0.04, 0,0 );
    txtFacebook.SetTextSize( 16 );
    txtFacebook.SetTextColor("#56AEF2");
    txtFacebook.SetHtml( "<u>Facebook</u>" );
    txtFacebook.SetOnTouchDown( txtFacebook_OnTouchDown );
    layAbout.AddChild( txtFacebook );
    
    var btnLicenses = app.CreateButton("Licenses");
    btnLicenses.SetMargins( 0, 0.04, 0,0 );
    btnLicenses.SetTextSize( 16 );
    btnLicenses.SetOnTouch( btnLicenses_OnTouch );
    layAbout.AddChild( btnLicenses );   

    //Add dialog layout and show dialog.
    dlgAbout.AddLayout( layAbout );
    dlgAbout.Show();
}

//Launch forum link,
function txtForum_OnTouchDown()
{
	app.OpenUrl( "http://groups.google.com/forum/#!forum/androidscript" );
}

//Launch twitter link,
function txtTwitter_OnTouchDown()
{
	app.OpenUrl( "http://twitter.com/android_script" );
}

//Launch Facebook link,
function txtFacebook_OnTouchDown()
{
	app.OpenUrl( "https://www.facebook.com/DroidScript" );
}

// Show the license information
function btnLicenses_OnTouch()
{
    dlgLicense = app.CreateDialog("Licenses");
    layLicense = app.CreateLayout( "Linear", "Vertical, FillXY" );
    layLicense.SetPadding( 0.025, 0, 0.025, 0 );
    
    // Android Trademark
    var licenseText = "<p>Android is a trademark of Google Inc.</p>";
    
    // Android Robot License
    licenseText += "<p>The Android robot is reproduced or modified from work created and shared " +
    " by Google and used according to terms described in the " +
    "<a href=http://creativecommons.org/licenses/by/3.0/>Creative Commons 3.0</a> " +
    "Attribution License.</p>";
    
    // Google Play Trademark
    licenseText += "<p>Google Play is a trademark of Google Inc.</p>";
    
    licenseText += "<p><b>DroidScript and the Wifi IDE make use of the following projects:</b></p>"
    
    // Jetty License
    licenseText += "<p><a href=http://www.eclipse.org/jetty/>Jetty Web Container</a> is " +
    "Copyright Mort Bay Consulting Pty Ltd, and licensed under the "+
    "<a href=http://www.apache.org/licenses/LICENSE-2.0.html>Apache 2.0 License</a>.</p>";
    
    // Font Awesome License
    licenseText += "<p><a href=http://fortawesome.github.io/Font-Awesome/>Font Awesome</a> by Dave Gandy " +
    "is licensed under the "+
    "<a href=http://scripts.sil.org/OFL>SIL OFL 1.1</a>.</p>";
    
    // Ace License
    licenseText += "<p><a href=http://ace.c9.io/>Ace</a> is Copyright Ajax.org B.V. " +
    "and licensed under the <a href=https://github.com/ajaxorg/ace/blob/master/LICENSE>BSD License</a>.</p>"
    
    // Bootstrap License
    licenseText += "<p><a href=http://getbootstrap.com/>Bootstrap</a> is Copyright Twitter Inc, and licensed " +
    "under the <a href=https://github.com/twbs/bootstrap/blob/master/LICENSE>MIT License</a>.</p>"
    
    // jQuery and jQueryMobile
    licenseText += "<p><a href=http://jquery.com/>jQuery</a> and <a href=http://jquerymobile.com/>jQuery Mobile</a> "+
    "are Copyright The jQuery Foundation and licensed unde the <a href=https://jquery.org/license/>MIT License</a>.</p>";
    
    // Uglify License
    licenseText += "<p><a href=https://github.com/mishoo/UglifyJS>UglifyJS</a> is Copyright Mihai Bazon " +
    "and licensed under the <a href=https://github.com/mishoo/UglifyJS/blob/master/README.org#license>BSD License</a>.</p>";
    
    // jqPlot
    licenseText += "<p><a href=http://www.jqplot.com/>jqPlot</a> by Chris Leonello " +
    "is licensed under the <a href=http://opensource.org/licenses/MIT>MIT License</a>.</p>";
    
    // HTML5 Canvas Gauage
    licenseText += "<p><a href=https://github.com/Mikhus/canv-gauge>HTML5 Canvas Gauge</a> is Copyright Mykhailo Stadnyk " +
    "and licensed under the <a href=http://opensource.org/licenses/MIT>MIT License</a>.</p>";
       
    var txtLicense = app.CreateText( licenseText, 1.0, -1, "Html,Link,Left" );
    txtLicense.SetTextSize( 14 );
    layLicense.AddChild( txtLicense );
    
    //Add dialog layout and show dialog.
    dlgLicense.AddLayout( layLicense );
    dlgLicense.Show();
}

//Handle IDE commands (via jetty web service).
function OnIDE( cmd, param1 )
{
	isWebIDE = true;
	g_debugParams = "remote";
	
    if( cmd=="refresh" )
    {
        ShowIcons();
    }
    else if( cmd=="run" ) {
		LaunchApp( param1 );
    }
    else if( cmd=="demo" )
    {
		app.MakeFolder( "/sdcard/" + app.GetName() + "/~demo" );
		app.WriteFile( "/sdcard/" + app.GetName() + "/~demo/~demo.js", decodeURIComponent(param1) );
		app.StartApp( "/sdcard/" + app.GetName() + "/~demo/~demo.js" );	
    }
    else if( cmd=="sample" )
    {
		isSample = true;
		app.StartApp( "/assets/samples/"+param1+".js", "remote" );
    }
}

//Create a project package.
function CreatePackage( appName )
{
    //Create project zip file.
    var zip = app.CreateZipUtil();
	var fldr = app.GetPath()+"/"+appName;
	//var file = fldr+".spk";
	var file = tempFldr+"/"+appName+".spk";
	zip.Create( file );
	
	//Add project files.
	//var appPath = app.GetPath();
    AddFolder( zip, appName, fldr );
	
	//Close zip file.
	zip.Close();
}

//Recursively add folder contents to zip.
function AddFolder( zip, name, fldr )
{
    var list = app.ListFolder( fldr,"");
    for( var i=0; i<list.length; i++ )
    {
        var title = list[i];
        //if( title.indexOf(".")>-1 )
        if( !app.IsFolder( fldr+"/"+title ) )
            zip.AddFile( name+"/"+title, fldr+"/"+title );
        else
            AddFolder( zip, name+"/"+title, fldr+"/"+title );
    }
}

//Check an spk package.
function CheckPackage( file )
{
    //Create zip util.
    zip = app.CreateZipUtil();
    zip.Open( file );
    
    //Get top level entry.
    var list = zip.List( "/" );
    zip.Close();
    
    //Check for valid package.
    if( !list ) { 
        app.ShowPopup("Invalid package!");
        return; 
    }
    //Check for overwrite.
    var lst = list.split(",");
    var fldr = app.GetPath();
    if( app.FolderExists( fldr+"/"+lst[0] ) ) {
        var overwriteDiag = app.CreateYesNoDialog( "Overwrite existing App?" );
        overwriteDiag.SetOnTouch( overwriteDiag_OnTouch );
    }
    else {
		//Install package.
		InstallPackage( file );
		app.ShowPopup( "Package installed" );
    }
}

//Handle overwrite spk dialog.
function overwriteDiag_OnTouch( result )
{
    if( result=="Yes" ) {
	    InstallPackage( spkFile );
	    app.ShowPopup( "Package installed" );
    }
	else
	    app.ShowPopup( "Package not installed" );
}

//Install an spk package.
function InstallPackage( file )
{
    //Create project zip file.
    var zip = app.CreateZipUtil();
    zip.Open( file );
    
    //Extract files and folders.
    var fldr = app.GetPath();
    ExtractFiles( zip, "/", fldr );
    
    //Close zip file.
	zip.Close();
	
	//Refresh icons.
	ShowIcons();
}

//Recursively extract zip contents.
function ExtractFiles( zip, path, fldr )
{
    var list = zip.List( path );
    if( !list ) { app.ShowPopup("Invalid package!"); return; }
    
    var lst = list.split(",");
    for( var i=0; i<lst.length; i++ )
    {
        var name = lst[i];
        if( name.indexOf("/")==-1) {
            //alert( "file=" + fldr+path+name );
            zip.Extract( (path+name).substr(1), fldr+path+name )
        }
        else {
            //alert( "dir="+ fldr+(path+name).slice(0,-1) );
            app.MakeFolder( fldr+(path+name).slice(0,-1) )
            ExtractFiles( zip, path+name, fldr );
        }
    }
}



//Show the plugins dialog.
function ShowPlugins()
{
    //Create dialog window.
    dlgPlug = app.CreateDialog( "Plugins" );
    layPlug = app.CreateLayout( "linear", "vertical,fillxy" );
    layPlug.SetPadding( 0.02, 0, 0.02, 0 );

    //Create a web control.
    webPlug = app.CreateWebView( 0.90, 0.65 );
    webPlug.SetMargins( 0, 0.01, 0, 0 ); 
    webPlug.SetOnProgress( webPlug_OnProgess );
    layPlug.AddChild( webPlug );

    //Create OK and Cancel buttons.
    layPlug2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    layPlug2.SetMargins( 0, 0.01, 0, 0.01 );  
    btnPlugOK = app.CreateButton( "OK", 0.3, -1, "" );
    btnPlugOK.SetOnTouch( btnPlugOK_OnTouch );
    layPlug2.AddChild( btnPlugOK );
    layPlug.AddChild( layPlug2 );

    //Add dialog layout and show dialog.
    dlgPlug.AddLayout( layPlug );
    dlgPlug.Show();
    
    //Load page
    app.ShowProgress("Loading...");
    setTimeout( "app.HideProgress()", 7000 );
    if( g_test ) webPlug.LoadUrl( "http://www.androidscript.org/PluginsTest/Plugins.html" );
    else webPlug.LoadUrl( "http://www.androidscript.org/Plugins/Plugins.html" );
}

//Show page load progress.
function webPlug_OnProgess( progress )
{
    if( progress==100 ) app.HideProgress();
}

//Check plugins are licensed.
function CheckLicenses()
{
    //Create Google Play object (if not done).
    if( !playStore ) playStore = app.CreatePlayStore();
    
    setTimeout( "playStore.GetPurchases(OnLicenses)", 1000 );
}

//Save licenses.
function OnLicenses( items )
{
    for( var i=0; i<items.length; i++ )
        purchases[items[i].productId] = (items[i].purchaseState==0);
}

//Get prices from google play etc.
function UpdatePluginInfo( prodIDs, versions )
{
    //Store version info for each plugin.
    var pluginIDs = prodIDs.split(",");
    var vers = versions.split(",");
    for( var i=0; i<pluginIDs.length; i++ )
        pluginVersions[pluginIDs[i]] = parseFloat(vers[i]);
    
    //Get product info from Google Play.
    //(Only paid items will be listed in OnStoreInfo)
    playStore.GetBillingInfo( prodIDs, OnStoreInfo );
}

//Show Play Store prices.
function OnStoreInfo( items )
{
    //Show prices.
    for( var i=0; i<items.length; i++ )
    {
        var prodId = items[i].productId.replace(".","_").replace(".","_");
        var div = prodId+"_price";
        var price = items[i].price;
        webPlug.Execute( div+".innerHTML='"+price+"'" );
    }
    
    //Set 'Buy/Reinstall/Update' button states.
    playStore.GetPurchases( OnPurchases );
}

//Show Play Store item info.
function OnPurchases( items )
{
    for( var i=0; i<items.length; i++ )
    {
        //Get appropriate button label.
        var prodId = items[i].productId.replace(".","_").replace(".","_");
        var btn = prodId+"_button";
        var label = (items[i].purchaseState==0 ? "Reinstall" : "Buy" );
        
        //Update html.
        webPlug.Execute( "document.getElementById('"+btn+"').value='"+label+"'" );
        
        //If purchased, check plugin version.
        if( items[i].purchaseState==0 ) 
        {
			CheckPluginVersion( prodId );
			/*
            //Get local plugin version.
            var plgName = prodId.replace("plugin_","");
            //test plgName = "ApkBuilder";
            var privDir = app.GetPrivateFolder( "Plugins" );
            var plgFile = privDir+"/"+plgName+"/Version.txt";
            var version = parseFloat( app.ReadFile( plgFile ));
            
            //Get remote version.
            var versionRem = pluginVersions[items[i].productId];
            
            //Compare with versions and change label if neccessary.
            //alert( version + " vs " + versionRem  );
            if( version < versionRem ) label = " Update ";
            */
        }
        
        //Save purchased items.
        purchases[items[i].productId] = (items[i].purchaseState==0);
    }
}

//Update version state of free plugins.
function UpdateFreePluginInfo( prodIDs, versions )
{
    //Check and update version for each plugin.
    var pluginIDs = prodIDs.split(",");
    var vers = versions.split(",");
    for( var i=0; i<pluginIDs.length; i++ ) 
    {
        pluginVersions[pluginIDs[i]] = parseFloat(vers[i]);    
		CheckPluginVersion( pluginIDs[i] );
	}
}

//Check if plugin is up-to-date.
function CheckPluginVersion( prodId )
{
	//Get local plugin version.
    var plgName = prodId.replace("plugin_","");
    var privDir = app.GetPrivateFolder( "Plugins" );
    var plgFile = privDir+"/"+plgName+"/Version.txt";
    var version = parseFloat( app.ReadFile( plgFile ));
    
    //Get remote version.
    var versionRem = pluginVersions[prodId];
    
    //Compare with versions and change label if neccessary.
    if( version < versionRem ) 
    {
		//Update html.
		var label = " Update ";
		var btn = prodId+"_button";
		webPlug.Execute( "document.getElementById('"+btn+"').value='"+label+"'" );
	}
}

//Handle Plugins 'Buy' from Plugins HTML page.
function BuyPlugin( prodId )
{
	//Show warning/license message.
	var txt = "WARNING\n\n" + 
	    "This plugin is 'Beta' software and may contain bugs. \n\nDo agree that you will not hold droidscript.org" + 
		" or any holding companies responsible for damages or losses incurred due to the use of" +
		" this plugin.\n\n Do you agree?"
	yesNoBuy = app.CreateYesNoDialog( txt );
	yesNoBuy.SetOnTouch( yesNoBuy_OnTouch );
	yesNoBuy.prodId = prodId;
}

//Handle accepting/rejecting plugin license.
function yesNoBuy_OnTouch( result )
{
	//Start the purchase process. 
	if( result=="Yes" )
		playStore.Purchase( yesNoBuy.prodId, "xbx345xbx", OnPurchased );
}

//Handle completed purchase.
function OnPurchased( prodId )
{
    //Update purchase state.
    purchases[prodId] = true;
    
    //alert( "OnPurchased" + prodId );
    //Install the plugin.
    InstallPlugin( prodId );
    
    //Update 'buy' button to 'Reisntall'.
    prodId = prodId.replace(".","_").replace(".","_");
    var btn = prodId+"_button";
    var label ="Reinstall";
    webPlug.Execute( btn+".value='"+label+"'" );
}

//Handle Plugins 'Install' from Plugins HTML page.
function InstallPlugin( prodId )
{
    //Get plugin file name.
    var plugName = prodId.replace("plugin_","");
    
    //Test for plugin downloading.
    //test plugName = "ApkBuilder";
    
    //Set plugin file urls.
    var url = "http://www.androidscript.org/Plugins/";
    if( g_test )  url = "http://www.androidscript.org/PluginsTest/";
    var src = url + plugName + ".zip";
    
    //Set dest folder.
    var privDir = app.GetPrivateFolder( "Plugins" );
    plugDir = privDir+"/"+plugName;
    //plugDir = "/sdcard/.AndroidScript/Temp";
    app.MakeFolder( plugDir );
    plugFile = plugDir + "/" + plugName + ".zip";
    
    //Download plugin files from web.
    dload = app.CreateDownloader();
    dload.SetOnComplete( dload_OnComplete );
    dload.SetOnError( dload_OnError );
    dload.Download( src, plugDir );
}

//Handle Plugins 'OK' click.
function btnPlugOK_OnTouch()
{
    //Remove dialog.
    dlgPlug.Dismiss();
}

//Handle plugin download completion.
function dload_OnComplete()
{
    //Create project zip file.
    var zip = app.CreateZipUtil();
    zip.Open( plugFile );
    
    //Extract files and folders.
    var fldr = app.GetPath();
    ExtractFiles( zip, "/", plugDir );
    
    //Close zip file and delete it.
    zip.Close();
    app.DeleteFile( plugFile );
    //alert( "Done!" );
    app.ShowPopup( "Plugin installed!" );
}

//Handle plulgin download errors.
function dload_OnError()
{
	app.ShowPopup( "Download failed!" );
}

//Show the APK building dialog.
function ShowAPKDialog()
{
    //Create dialog window.
    dlgApk = app.CreateDialog( "Build APK" );
    layApk = app.CreateLayout( "linear", "vertical,fillxy" );
    layApk.SetPadding( 0.05, 0, 0.05, 0 );

    //Create 'package name' text box.
    var packTitle = curProgam.replace( RegExp( " ","gim"), "" ).toLowerCase();
    var packRoot = app.LoadText( "_userOrg", "com.myname", "spremote" );
    var packName = packRoot + "." + packTitle;
    packName = packName.replace("sw-","");
    packName = packName.replace("sws-","");
    txtApkPkg = app.CreateTextEdit( packName, 0.75 );
    layApk.AddChild( txtApkPkg );
    
    //Create 'version' text box.
    txtApkVer = app.CreateTextEdit( "1.00", 0.2 );
    layApk.AddChild( txtApkVer );
    
    //Create 'minify' checkbox.
    chkApkMin = app.CreateCheckBox( "Debug Build" );
    layApk.AddChild( chkApkMin );
    chkApkMin.SetChecked( true );
    
    //Create horizontal layout for Ok and Cancel buttons.
    layApk2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    layApk.AddChild( layApk2 );
    
    //Create OK button.
    layApk2.SetMargins( 0, 0.02, 0, 0.01 );  
    btnApkOK = app.CreateButton( "OK", 0.2 );
    btnApkOK.SetOnTouch( btnApkOK_OnTouch );
    layApk2.AddChild( btnApkOK );
    
    //Create Cancel button.
    btnApkCancel = app.CreateButton( "Cancel", 0.2 );
    btnApkCancel.SetOnTouch( btnApkCancel_OnTouch );
    layApk2.AddChild( btnApkCancel );
   
    //Add dialog layout and show dialog.
    dlgApk.AddLayout( layApk );
    dlgApk.Show();
    
    //Set default password.
    keyPass = "MyPassword";
}

function _LoadScriptX( url, callback )
{
    var head = document.getElementsByTagName('head')[0];
    var script = document.createElement('script');
    script.type = 'text/javascript';
    
    if( url.indexOf("http:") >-1 ) {
        script.src = url;
        script.onload = callback;
    }
    else {
         //if (url.charAt[0] !== '/') 
         //   url = app.GetAppPath() + "/" + url;
        script.text = app.ReadFile( url );
        //script.defer = true;
        if( callback ) callback();
    }
    head.appendChild(script);
}

function _LoadPluginX( name )
{
    var privDir = app.GetPrivateFolder( "Plugins" );
    _LoadScriptX( privDir+"/"+name.toLowerCase()+"/"+name+".inc" );
}

//Handle APK 'OK' click.
function btnApkOK_OnTouch()
{
	//Check package name is ok.
	var pkgName = txtApkPkg.GetText();
	var ret = pkgName.match( RegExp("(^|\\.)\\d","gim"), "" );
	if( ret ) { app.Alert( "Package name parts cannot start with numbers", "Name Error" ); return; }
	
	//Check version num is ok.
	var pkgVer = parseFloat(txtApkVer.GetText());
	if( isNaN( pkgVer ) ) { app.Alert( "Version number must be a decimal fraction", "Version Error" ); return; }
	
    //Get debug mode.
    debugApk = chkApkMin.GetChecked();
     
    //Check if we have a key store.
    keyFile = "/sdcard/DroidScript/APKs/user.keystore";
    keyFileDbg = "/sdcard/.DroidScript/debug.keystore";
    if( !debugApk && !app.FileExists( keyFile ) ) {
        ShowKeyStoreDialog();
        return;
    }
    
    //Build the APK.
    if( debugApk )  
        BuildAPK( txtApkPkg.GetText(), curProgam, 
            parseFloat(txtApkVer.GetText()), !debugApk, "android" );
    else
       ShowPasswordDialog();

	//Save users organisation.
	var org = txtApkPkg.GetText();
	org = org.substr( 0, org.lastIndexOf(".") );
	app.SaveText( "_userOrg", org, "spremote" );
	
    //Remove dialog.
    dlgApk.Dismiss();
}

//Handle APK 'Cancel' click.
function btnApkCancel_OnTouch()
{
    //test... delete me.
    //var privDir = app.GetPrivateFolder( "Plugins" );
    //var dst = privDir+"/myplugin/MyPlugin.jar";
    //app.DeleteFile( dst );
    //alert( app.Try() );
        
    //Remove dialog.
    dlgApk.Dismiss();
}

//Allow user to create key store.
function ShowKeyStoreDialog()
{
    //Create dialog window.
    dlgKey = app.CreateDialog( "Create Key" );
    layKey = app.CreateLayout( "linear", "vertical,fillxy" );
    layKey.SetPadding( 0.05, 0, 0.05, 0 );

    //Create info text.
    var info = "You must create a personal key to sign your APK" + 
        " files. Please enter a name, organization and password to " + 
        "generate your key.";
    txtKeyInfo = app.CreateText( info, 0.8, -1, "multiline" );
    txtKeyInfo.SetMargins( 0,0.04,0,0.04 );
    txtKeyInfo.SetTextSize( 16 );
    layKey.AddChild( txtKeyInfo );
     
    //Create 'Name' text box.
    txtKeyName = app.CreateTextEdit( "MyName", 0.6 );
    layKey.AddChild( txtKeyName );
    
    //Create 'Organization' text box.
    txtKeyOrg = app.CreateTextEdit( "MyOrganization", 0.6 );
    layKey.AddChild( txtKeyOrg );
    
    //Create 'Password' text box.
    txtKeyPass = app.CreateTextEdit( keyPass, 0.6 );
    layKey.AddChild( txtKeyPass );
    
    //Create horizontal layout for Ok and Cancel buttons.
    layKey2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    layKey.AddChild( layKey2 );
    
    //Create OK button.
    layKey2.SetMargins( 0, 0.02, 0, 0.01 );  
    btnKeyOK = app.CreateButton( "OK", 0.2 );
    btnKeyOK.SetOnTouch( btnKeyOK_OnTouch );
    layKey2.AddChild( btnKeyOK );
    
    //Create Cancel button.
    btnKeyCancel = app.CreateButton( "Cancel", 0.2 );
    btnKeyCancel.SetOnTouch( btnKeyCancel_OnTouch );
    layKey2.AddChild( btnKeyCancel );
   
    //Add dialog layout and show dialog.
    dlgKey.AddLayout( layKey );
    dlgKey.Show();
}

//Handle Key dialog 'OK' click.
function btnKeyOK_OnTouch()
{
    //Get user key info.
    var name = txtKeyName.GetText();
    var org = txtKeyOrg.GetText();
    
    //Make sure APK's folder exists.
    var apkFldr = app.GetPath()+"/APKs";
    app.MakeFolder( apkFldr );
    
    //Create a user key store file and key.
    app.ShowProgress("Creating key...");
    zip = app.CreateZipUtil();
    zip.CreateKey( keyFile, txtKeyPass.GetText(), name, org );
    app.HideProgress();
    
    //Show warning.
    var warn = "A 'user.keystore' file has now been created in the " +
        "DroidScript/APKs folder.\n\nIt is STRONGLY recomended that you " +
        "backup this file. You cannot update Google Play Apps released using " +
        "this key, unless you have the original file (and can also " +
        "remember the password!)\n\n" + 
        "Note: If you rename or delete this file, you will be asked to " +
        "create a new one again.";
    app.Alert( warn, "WARNING" );
    
    //Save current password to memory.
    keyPass = txtKeyPass.GetText();
    
    //Save user org to settings.
    app.SaveText( "_userOrg", "com."+txtKeyOrg.GetText(), "spremote" );
    
    //Remove dialog.
    dlgKey.Dismiss();
    dlgKey.Release();
}

//Handle Key dialog 'Cancel' click.
function btnKeyCancel_OnTouch()
{
     //Remove dialog.
    dlgKey.Dismiss();
    dlgKey.Release();
}

//Show the APK password dialog.
function ShowPasswordDialog()
{
    //Create dialog window.
    dlgPass = app.CreateDialog( "Enter Key Password" );
    layPass = app.CreateLayout( "linear", "vertical,fillxy" );
    layPass.SetPadding( 0.05, 0.05, 0.05, 0 );

    //Create 'Password' text box.
    txtPass = app.CreateTextEdit( keyPass, 0.6 );
    layPass.AddChild( txtPass );
    
    //Create horizontal layout for Ok and Cancel buttons.
    layPass2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    layPass.AddChild( layPass2 );
    
    //Create OK button.
    layPass2.SetMargins( 0, 0.02, 0, 0.01 );  
    btnPassOK = app.CreateButton( "OK", 0.2 );
    btnPassOK.SetOnTouch( btnPassOK_OnTouch );
    layPass2.AddChild( btnPassOK );
    
    //Create Cancel button.
    btnPassCancel = app.CreateButton( "Cancel", 0.2 );
    btnPassCancel.SetOnTouch( btnPassCancel_OnTouch );
    layPass2.AddChild( btnPassCancel );
   
    //Add dialog layout and show dialog.
    dlgPass.AddLayout( layPass );
    dlgPass.Show();
}

//Handle Pass dialog 'OK' click.
function btnPassOK_OnTouch()
{
    //Build the APK.
    BuildAPK( txtApkPkg.GetText(), curProgam, parseFloat(txtApkVer.GetText()), 
                    !debugApk, txtPass.GetText() );
                    
    //Remove dialog.
    dlgPass.Dismiss();
    dlgPass.Release();
}

//Handle Pass dialog 'Cancel' click.
function btnPassCancel_OnTouch()
{
    //Remove dialog.
    dlgPass.Dismiss();
    dlgPass.Release();
}

function BuildAPK( packageName, appName, version, minify, pass )
{
    try
    {
        //Show progress dialog.
        app.ShowProgressBar( "Building APK...", 0 );
         
        //Create APK plugin (if not created yet).
        if( !plgApk ) 
        {
            _LoadPluginX( "ApkBuilder" );
            plgApk = app.CreateObject( "ApkBuilder" );
            if( plgApk==null ) return; 
           
            var privDir = app.GetPrivateFolder( "Plugins" );
           _LoadScriptX( privDir+"/apkbuilder/Uglify/parse-js.js")
           _LoadScriptX( privDir+"/apkbuilder/Uglify/process.js")
           _LoadScriptX( privDir+"/apkbuilder/Uglify/consolidator.js")
        }
        
        //Copy base unsigned, unmanifested apk to temp folder.
        var apkFldr = app.GetPath()+"/APKs";
        var tmpFldr = "/sdcard/.DroidScript/Temp";
        var appFldr = app.GetPath()+"/"+appName;
        var privDir = app.GetPrivateFolder( "Plugins" );
        
        //Deal with smartwatch apps.
        var isWatchApp = false; var ops = "Launch";
        if( appName.indexOf("SWS-")>-1 || appName.indexOf("SW-")>-1 ) {
            isWatchApp = true;
            ops = "";
        }
        var newName = appName.replace("SWS-", "");
        newName = newName.replace("SW-", "");
        
        //Create output apk file.
        var zipOut = app.CreateZipUtil();
        zipOut.Create( tmpFldr+"/"+newName+".apk" );
       
        //Open base apk file.
        var zipIn = app.CreateZipUtil();
        zipIn.Open( privDir+"/apkbuilder/eng.dat" );
        
        //Add new app icon.png file.
        var mainIcon = appFldr+"/Img/"+appName+".png";
        if( app.FileExists( mainIcon ) ) {
			zipOut.AddFile( "res/drawable/icon.png", mainIcon );
			zipOut.AddFile( "res/drawable-xhdpi/icon.png", mainIcon );
		}
		else {
			app.CopyFile( "/Sys/Img/Icon.png", tmpFldr+"/Icon.png" );
			zipOut.AddFile( "res/drawable/icon.png", tmpFldr+"/Icon.png" );
			zipOut.AddFile( "res/drawable-xhdpi/icon.png", tmpFldr+"/Icon.png" );
		}
			
        //Add watch icon (if present). 
        var watchIcon = appFldr+"/Img/"+appName+"-48x48.png"
        if( app.FileExists(watchIcon) ) 
            zipOut.AddFile( "res/drawable/icon_extension48.png", watchIcon );
         
        //Add user's files (and scan for permissions).
        permissions = "";
        AddFolderWithScan( zipOut, "assets/user", appFldr, appName, minify );
         
        //Loop through adding rest of base apk contents.
        var lst = zipIn.List().split(",");
        for( var i=0; i<lst.length; i++ )
        {
            //Extract file from source and add to dest.
            zipIn.Extract( lst[i], tmpFldr+"/tmp.dat" );
            zipOut.AddFile( lst[i], tmpFldr+"/tmp.dat" );
            
            //Update progress.
            app.UpdateProgressBar( i * 100/ lst.length );
        }
        
        //Add new manifest file using template.
        plgApk.UpdateManifest( privDir+"/apkbuilder/amf.dat", tmpFldr+"/tmp.dat", 
                packageName, newName, version, permissions, ops );
        zipOut.AddFile( "AndroidManifest.xml", tmpFldr+"/tmp.dat" );
        
        //Close zip files.
        zipIn.Close();
        zipOut.Close();
        
        //Create a debug key store if not done.
        if( !app.FileExists( keyFileDbg ) ) zipOut.CreateDebugKey( keyFileDbg );
    
        //Sign apk.
        app.MakeFolder( apkFldr );
        var ok = zipOut.Sign( tmpFldr+"/"+newName+".apk", 
                apkFldr+"/"+newName+".apk", debugApk?keyFileDbg:keyFile, pass );
        if(!ok) { app.Alert( "Bad Password or Key file!", "Error" ); return; }
        
        //Remove unsigned version.
        app.DeleteFile( tmpFldr+"/"+newName+".apk" );
        
        //Tell user where APK is.
        app.ShowPopup( "APK created in folder: /DroidScript/APKs", "Long" );
    }
    finally {
        //Hide progess dialog.
        app.HideProgressBar();
    }
}

//Recursively add folder contents to zip.
function AddFolderWithScan( zip, name, fldr, appName, minify )
{
    var list = app.ListFolder( fldr,"");
    for( var i=0; i<list.length; i++ )
    {
        var title = list[i];
        //if( title.indexOf(".")>-1 ) 
        if( !app.IsFolder( fldr+"/"+title ) )
        {
            //Scan .js files for permissions.
            var isJs = (title.toLowerCase().indexOf(".js") > -1 );
            if( isJs ) ScanFile( fldr+"/"+title );
            
            //Change to main.js if main file.
            var newtitle = title;
            if( title.toLowerCase()==(appName.toLowerCase()+".js" ) )
                newtitle = "main.js";
                
            //Swap spaces for underscores (for ICS bug)
            newtitle = newtitle.replace(" ","_");
            
            //Add file to zip (with minify if req).
            if( minify && isJs ) {
                var code = app.ReadFile( fldr+"/"+title );
                zip.AddText( name+"/"+newtitle, uglify( code ) );
            }
            else zip.AddFile( name+"/"+newtitle, fldr+"/"+title );
        }
        else
            AddFolderWithScan( zip, name+"/"+title, fldr+"/"+title, appName, minify );
    }
}

//Scan a file for required Android permissions.
function ScanFile( file )
{
    var src = app.ReadFile( file );
    
    if( src.indexOf("app.CreateNetClient") > -1 ) AddPermission("Network");
    if( src.indexOf("XMLHttpRequest") > -1 ) AddPermission("Network");
    if( src.indexOf("app.GetIPAddress") > -1 ) AddPermission("Network");
    if( src.indexOf("app.GetMacAddress") > -1 ) AddPermission("Network");
    if( src.indexOf("app.CreateWebServer") > -1 ) AddPermission("Network");
    if( src.indexOf("app.CreateEmail") > -1 ) AddPermission("Network");
    if( src.indexOf("\"http://") > -1 ) AddPermission("Network");
    if( src.indexOf("\"https://") > -1 ) AddPermission("Network");
    if( src.indexOf("\"rtsp://") > -1 ) AddPermission("Network");
    if( src.indexOf("\"ftp://") > -1 ) AddPermission("Network");
    if( src.indexOf("'http://") > -1 ) AddPermission("Network");
    if( src.indexOf("'https://") > -1 ) AddPermission("Network");
    if( src.indexOf("'rtsp://") > -1 ) AddPermission("Network");
    if( src.indexOf("'ftp://") > -1 ) AddPermission("Network");
    
    if( src.indexOf("app.CreateCameraView") > -1 ) AddPermission("Camera");
    if( src.indexOf("app.CreateLocator") > -1 ) AddPermission("Location");
    if( src.indexOf("app.CreateSMS") > -1 ) AddPermission("SMS");
    
    if( src.indexOf("app.PreventScreenLock") > -1 ) AddPermission("WakeLock");
    if( src.indexOf("app.PreventWifiSleep") > -1 ) AddPermission("WakeLock");
    
    if( src.indexOf("app.CreateShortcut") > -1 ) AddPermission("Shortcut");
    if( src.indexOf("app.Vibrate") > -1 ) AddPermission("Vibrate");
    if( src.indexOf("app.CheckLicense") > -1 ) AddPermission("License");
    
    if( src.indexOf("app.CreateNxt") > -1 ) AddPermission("Bluetooth");
    if( src.indexOf("app.IsBluetoothOn") > -1 ) AddPermission("Bluetooth");
    if( src.indexOf("app.CreateBluetoothSerial") > -1 ) AddPermission("Bluetooth");
    
    if( src.indexOf("app.FileExists") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.IsFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.FolderExists") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.WriteFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.ReadFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CopyFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CopyFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.DeleteFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.OpenFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.DeleteFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.MakeFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.ListFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.RenameFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.RenameFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.GetExternalFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("\"file://") > -1 ) AddPermission("Storage");
    if( src.indexOf("'file://") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CreateAudioRecorder") > -1 ) AddPermission("Storage");
    
    if( src.indexOf("app.CreateContacts") > -1 ) AddPermission("Contacts");
    if( src.indexOf("app.CreateSmartWatch") > -1 ) AddPermission("SmartWatch2");
    if( src.indexOf("app.CreatePlayStore") > -1 ) AddPermission("Vending");
    
    if( src.indexOf("app.CreateAudioRecorder") > -1 ) AddPermission("Record");
    if( src.indexOf("app.CreateSpeechRec") > -1 ) AddPermission("Record");
    
    if( src.indexOf("app.Call") > -1 ) AddPermission("Phone");
    
}

//Add a permission (if not already added)
function AddPermission( perm )
{
    if( permissions.indexOf( perm )==-1 ) 
    {
        if( permissions ) permissions += ","; 
        permissions += perm; 
    }
}

//Minify javascript code.
function require() {}
function uglify( orig_code, options )
{
  options || (options = {});
    
  var ast = parse( orig_code );       // parse code and get the initial AST
  ast = ast_mangle( ast);            // get a new AST with mangled names
  ast = ast_squeeze( ast );          // get an AST with compression optimizations
  var final_code = gen_code( ast );  // compressed code here
  
  //alert( final_code );
  return final_code;
};

//Check for plugin updates etc
function CheckForUpdates()
{
    try {
    	var url = "http://www.androidscript.org/News/Version.json";
        var xmlHttp = new XMLHttpRequest();
        xmlHttp.onreadystatechange = function() { HandleReply(xmlHttp); };  
        xmlHttp.open("GET", url, true);
        xmlHttp.send(null);
    }
    catch(e) {}
}

//Handle the servers reply (version number)
function HandleReply( xmlHttp )
{
    try
    {
        if( xmlHttp.readyState==4 )
        {
            //If we got a valid response.
            if( xmlHttp.status==200 )
            {
                var info = JSON.parse(xmlHttp.responseText);
                //app.ShowPopup( "Response: " + info.version );
                var lastVersion = app.LoadNumber( "_LastNewsVersion", 0, "spremote" );
                if( info.version > lastVersion ) { 
                    ShowNews();
                    app.SaveNumber( "_LastNewsVersion", info.version, "spremote" );
                }
            }
        }
    }
    catch(e) {}
}

//Show the news dialog.
function ShowNews()
{
    //Create dialog window.
    dlgNews = app.CreateDialog( "News", "NoTitle" );
    layNews = app.CreateLayout( "linear", "vertical,fillxy" );
    layNews.SetPadding( 0.02, 0, 0.02, 0 );

    //Create a web control.
    webNews = app.CreateWebView( 0.90, 0.65 );
    webNews.SetMargins( 0, 0.01, 0, 0.01 ); 
    //webNews.SetOnProgress( webPlug_OnProgess );
    layNews.AddChild( webNews );
    webNews.LoadHtml( "Loading News...", "file:///Sys/" );

    //Add dialog layout and show dialog.
    dlgNews.AddLayout( layNews );
    dlgNews.Show();
    
    //Load page
    setTimeout( LoadNews, 100 );
}

//Load the news
function LoadNews()
{
    var url = "http://androidscript.org/News/News.html";
    webNews.LoadUrl( url  );
}

//Rename AS folder to DS.
//(Called from app.js before extract)
function _CheckFolderName()
{
    if( app.FolderExists( "/sdcard/AndroidScript" ) )
    {
        if( !app.FolderExists( "/sdcard/DroidScript" ) )
           app.RenameFolder( "/sdcard/AndroidScript", "/sdcard/DroidScript" );
    }
}
