
//Called when application is started.
function OnStart()
{
	//Create a layout with objects vertically centered.
	lay = app.CreateLayout( "linear", "VCenter,FillXY" );

	//Create a web control to show guage.
	web = app.CreateWebView( 0.9, 0.4 );
	lay.AddChild( web );
	
	//Create a text control.
	txt = app.CreateText( "", 0.5, -1 );
	txt.SetMargins( 0, 0.05, 0, 0 );
	lay.AddChild( txt );
	
	//Create spinner control to select graph style.
	var styles = "Plot,Curve,Bar,Pie";
	spinStyle = app.CreateSpinner( styles, 0.5, -1 );
	spinStyle.SetMargins( 0, 0.1, 0, 0 );
	spinStyle.SetOnTouch( spinStyle_OnTouch );
	lay.AddChild( spinStyle );
	
	//Add layout to app.	
	app.AddLayout( lay );
	
	//Load web page.
	fldr = "file:///Sys/Html/jqPlot/";
	web.LoadUrl( fldr + "Plot.html" );
}

//Called when user touches style spinner.
function spinStyle_OnTouch( item )
{
	web.LoadUrl( fldr + item + ".html" );
	txt.SetText( "" );
}

//Called by html page when bar graph is touched.
function ShowData( data )
{
	txt.SetText( data );
}
