//This sample demonstrates getting a list of UK place names
//within a post code area using the free geonames.org web service.

//Called when application is started.
function OnStart()
{
    //Create a layout with objects vertically centered.
    lay = app.CreateLayout( "linear", "VCenter,FillXY" );    

    //Create an text edit box for postcode entry. 
	edt = app.CreateTextEdit( "CB1", 0.8 ); 
	lay.AddChild( edt ); 

    //Create a button to send request.
	btn = app.CreateButton( "Get Places", 0.3, 0.1 ); 
	btn.SetMargins( 0, 0.05, 0, 0 ); 
    btn.SetOnTouch( btn_OnTouch ); 
	lay.AddChild( btn ); 

    //Create a text label to show results.
    txt = app.CreateText( "", 0.8, 0.6, "Left,Multiline" ); 
	txt.SetBackColor( "#ff222222" ); 
    txt.SetTextSize( 12 );
    lay.AddChild( txt );
    
    //Add layout to app.    
    app.AddLayout( lay );

}   

//Handle button press.
function btn_OnTouch() 
{ 
  //Send request to remote server.
  var postCode = edt.GetText();
  var url = "http://api.geonames.org/postalCodeLookupJSON?"
        + "postalcode=" + postCode + "&country=UK&username=androidscript";
  SendRequest( url  );
}

//Send an http get request.
function SendRequest( url )
{
    var httpRequest = new XMLHttpRequest();
    httpRequest.onreadystatechange = function() { HandleReply(httpRequest); };  
    httpRequest.open("GET", url, true);
    httpRequest.send(null);
    
    app.ShowProgress( "Loading..." );
}

//Handle the server's reply (a json object).
function HandleReply( httpRequest )
{
    if( httpRequest.readyState==4 )
    {
        //If we got a valid response.
        if( httpRequest.status==200 )
        {
            txt.SetText( "Response: " + httpRequest.status + httpRequest.responseText);
        }
        //An error occurred
        else
            txt.SetText( "Error: " + httpRequest.status + httpRequest.responseText);
    }
  app.HideProgress();
}

